## dtkcore 5.7.12

=== docs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

find_package (Doxygen REQUIRED)
set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt${QT_VERSION_MAJOR}/doc CACHE STRING "QCH install location")

set (DOXYGEN_GENERATE_HTML YES CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML YES CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP YES CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")

if("${QT_VERSION_MAJOR}" STREQUAL "5")
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Help)
else()
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS ToolsTools)
endif()
get_target_property(_qhelpgenerator_location Qt${QT_VERSION_MAJOR}::qhelpgenerator IMPORTED_LOCATION)

if("${_qhelpgenerator_location}" STREQUAL "")
    set(_qhelpgenerator_location "qhelpgenerator")
endif()
set (DOXYGEN_QHG_LOCATION ${_qhelpgenerator_location} CACHE STRING "Doxygen QHG path")

set (DOXYGEN_QHP_NAMESPACE "org.deepin.dtk.core")
set (DOXYGEN_QCH_FILE "dtkcore.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER "dtkcore")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)

set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://org.qt-project.qtcore/qtcore/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_IMAGE_PATH ${PROJECT_SOURCE_DIR}/docs/src)
set (DOXYGEN_SOURCE_BROWSE "YES")

set (BUILD_THEME OFF CACHE BOOL "Build doxgen theme")
if(BUILD_THEME)
if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/doxygen-theme")
message(STATUS "doxygen-theme exists")
else()
execute_process(COMMAND git clone https://github.com/linuxdeepin/doxygen-theme.git --depth=1
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        TIMEOUT 60
    )
execute_process(COMMAND bash themesetting.sh
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/doxygen-theme/
)
endif()
set (DOXYGEN_HTML_EXTRA_STYLESHEET "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome.css"
                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only.css"
                                "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-sidebar-only-darkmode-toggle.css"
                                )
set (DOXYGEN_HTML_EXTRA_FILES "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-darkmode-toggle.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-fragment-copy-button.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-paragraph-link.js"
                            "docs/doxygen-theme/doxygen-awesome-css/doxygen-awesome-interactive-toc.js"
                            )
set (DOXYGEN_GENERATE_TREEVIEW "YES")
set (DOXYGEN_DISABLE_INDEX "NO")
set (DOXYGEN_FULL_SIDEBAR "NO")
set (DOXYGEN_HTML_HEADER "docs/doxygen-theme/doxygen-awesome-css/header.html")
set (DOXYGEN_HTML_FOOTER "docs/doxygen-theme/doxygen-awesome-css/footer.html")
endif()

set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_PREDEFINED
    "DCORE_BEGIN_NAMESPACE=namespace Dtk { namespace Core {"
    "DCORE_END_NAMESPACE=}}"
    "DCORE_USE_NAMESPACE=using namespace Dtk::Core;"
    "Q_OS_LINUX=1"
)
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")

doxygen_add_docs (doxygen
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/docs
    ALL
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${PROJECT_BINARY_DIR}/docs/html/dtkcore.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/CMakeLists.txt ===
add_subdirectory(expintf-example)
add_subdirectory(textcodec-example)
add_subdirectory(filewatcher-example)
add_subdirectory(dlog-example)

=== src/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.5)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Dtk${DTK_VERSION_MAJOR}Log REQUIRED)
if(LINUX)
  find_package(PkgConfig REQUIRED)
  find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
      pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt) #Dtk6 removed.
  endif()

endif()
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Xml)
find_package(DtkBuildHelper REQUIRED)

# start text encoding
find_package(ICU REQUIRED COMPONENTS uc)
pkg_check_modules(uchardet REQUIRED uchardet)
# end text encoding

# start base
include(base/base.cmake)
# end base

# start dci
include(dci/dci.cmake)
#end dci

#start filesystem
include(filesystem/filesystem.cmake)
#end filesystem
# start log
include(log/log.cmake)
#end log
# start settings
include(settings/settings.cmake)
#end settings

#start utils
include(util/util.cmake)
#end utils

#GLOB
include(glob.cmake)
#endGLOG
if(LINUX)
  add_library(${LIB_NAME} SHARED
    ${base_SRCS}
    ${dci_SRCS}
    ${filesystem_SRCS}
    ${log_SRCS}
    ${settings_SRC}
    ${utils_SRC}
    ${glob_SRC}
  )
  target_link_libraries(
    ${LIB_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Xml
    Dtk${DTK_VERSION_MAJOR}::Log
  )
  target_link_libraries(${LIB_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::CorePrivate
  )
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
    target_link_libraries(${LIB_NAME} PRIVATE
      PkgConfig::QGSettings
    )
  endif()

else()
  add_library(${LIB_NAME} SHARED
    ${base_SRCS}
    ${dci_SRCS}
    ${filesystem_SRCS}
    ${log_SRCS}
    ${settings_SRC}
    ${utils_SRC}
    ${glob_SRC}
  )
  target_link_libraries(
    ${LIB_NAME} PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Xml
  )
  target_link_libraries(${LIB_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::CorePrivate
  )
  if("${QT_VERSION_MAJOR}" STREQUAL "5")
    target_link_libraries(${LIB_NAME} PRIVATE
      PkgConfig::QGSettings
    )
  endif()
endif()
set_target_properties(${LIB_NAME} PROPERTIES
  VERSION ${CMAKE_PROJECT_VERSION}
  SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
  EXPORT_NAME Core
)

target_compile_definitions(${LIB_NAME} PUBLIC
    PREFIX="${DSG_PREFIX_PATH}"
    DSYSINFO_PREFIX="${DSYSINFO_PREFIX}"
)

target_compile_definitions(${LIB_NAME} PRIVATE
    LIBDTKCORE_LIBRARY
)

target_include_directories(${LIB_NAME} PRIVATE
  ${uchardet_INCLUDE_DIRS}
)
target_include_directories(${LIB_NAME} PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/util>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/dci>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/log>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/base>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/base/private>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DtkCore>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/settings>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/filesystem>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
)

target_include_directories(${LIB_NAME} INTERFACE
  $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

target_link_directories(${LIB_NAME} INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:${LIBRARY_INSTALL_DIR}>
)

set(EnableCov CACHE BOOL OFF)
if (EnableCov)
    dtk_setup_code_coverage(${LIB_NAME})
endif()

dtk_check_and_add_definitions(${LIB_NAME}
    DEFS
    OS_VERSION_TEST_FILE
    LSB_RELEASE_TEST_FILE
    OS_RELEASE_TEST_FILE
    DEEPIN_VERSION_TEST_FILE
)

set(TOINSTALLBASE
  ../include/base/dobject.h
  ../include/base/dsingleton.h
  ../include/base/private/dobject_p.h
  ../include/base/derror.h
  ../include/base/dexpected.h
)
install(FILES ${TOINSTALLBASE} DESTINATION "${INCLUDE_INSTALL_DIR}")
install(FILES ${LOG_HEADER} DESTINATION "${INCLUDE_INSTALL_DIR}")
install(FILES ${SETTINGS_HEADERS} DESTINATION "${INCLUDE_INSTALL_DIR}")
install(FILES ${UTILS_HEADERS} DESTINATION "${INCLUDE_INSTALL_DIR}")

install(DIRECTORY ../include/dci/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")
install(DIRECTORY ../include/DtkCore/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*")
install(DIRECTORY ../include/filesystem/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")
install(DIRECTORY ../include/global/ DESTINATION "${INCLUDE_INSTALL_DIR}" FILES_MATCHING PATTERN "*.h")

install(TARGETS ${LIB_NAME} EXPORT ${DtkCore}Targets
 DESTINATION ${LIBRARY_INSTALL_DIR})

install(EXPORT ${DtkCore}Targets
  FILE ${DtkCore}Targets.cmake
  NAMESPACE Dtk${DTK_VERSION_MAJOR}::
  DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
)

=== tools/CMakeLists.txt ===
add_subdirectory(dci)
add_subdirectory(deepin-os-release)
add_subdirectory(qdbusxml2cpp)
add_subdirectory(settings)
add_subdirectory(ch2py)
add_subdirectory(dconfig2cpp)

=== examples/dlog-example/CMakeLists.txt ===
set(BIN_NAME dlog${DTK_VERSION_MAJOR})
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

add_executable(${BIN_NAME}
  main.cpp
)

target_link_libraries(
  ${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::Core
  ${LIB_NAME}
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../include/
)

=== examples/expintf-example/CMakeLists.txt ===
set(BIN_NAME exprintf${DTK_VERSION_MAJOR})
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)

add_executable(${BIN_NAME}
  main.cpp
)

target_link_libraries(
  ${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::DBus 
  ${LIB_NAME}
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../include/base
  ../../include/base/private/
  ../../include/filesystem/
  ../../include/
)

=== examples/filewatcher-example/CMakeLists.txt ===
set(BIN_NAME filewatcher${DTK_VERSION_MAJOR})

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

add_executable(${BIN_NAME}
    main.cpp
)

target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    ${LIB_NAME}
)

target_include_directories(${BIN_NAME} PUBLIC
    ../../include/filesystem/
    ../../include/
)

=== tests/testso/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Uniontech Software Technology Co.,Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

file(GLOB_RECURSE TESTSO "*.cpp" "*.h")

add_compile_options(-fno-sanitize=all)
add_link_options(-fno-sanitize=all)

add_library(${TEST_SO_NAME} SHARED ${TESTSO})

target_link_libraries(${TEST_SO_NAME} PUBLIC Qt${QT_VERSION_MAJOR}::Core)

=== tools/ch2py/CMakeLists.txt ===
set(TARGET_NAME ch2py)
set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

set(CMAKE_AUTORCC ON)
add_executable(${BIN_NAME}
    ${PROJECT_SOURCE_DIR}/src/util/dpinyin.cpp
    ${PROJECT_SOURCE_DIR}/src/util/util.qrc
    main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
)
target_include_directories(${BIN_NAME} PRIVATE
    ${PROJECT_SOURCE_DIR}/include/util
    ${PROJECT_SOURCE_DIR}/include/global
)
set_target_properties(${BIN_NAME} PROPERTIES OUTPUT_NAME ${TARGET_NAME})
install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== tools/dci/CMakeLists.txt ===
set(TARGET_NAME dci)
set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
add_definitions(-DDTK_NO_PROJECT)
# start dci
include(../../src/dci/dci.cmake)
add_executable(${BIN_NAME}
  ${dci_SRCS}
  main.cpp
)
target_link_libraries(${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::CorePrivate
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../include/
  ../../include/dci/
  ../../include/DtkCore/
  ../../include/base/
  ../../include/global/
)
set_target_properties(${BIN_NAME} PROPERTIES OUTPUT_NAME ${TARGET_NAME})
#end dci

install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== tools/deepin-os-release/CMakeLists.txt ===
set(TARGET_NAME deepin-os-release)
set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_AUTOMOC ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
add_definitions(-DDTK_NO_PROJECT)
# start dci
set(dci_SRCS
  ../../include/global/dsysinfo.h
  ../../include/global/ddesktopentry.h
  ../../src/dsysinfo.cpp
  ../../src/ddesktopentry.cpp
)
add_executable(${BIN_NAME}
  ${dci_SRCS}
  main.cpp
)

target_compile_definitions(${BIN_NAME} PUBLIC
    DSYSINFO_PREFIX="${DSYSINFO_PREFIX}")

target_link_libraries(${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::CorePrivate
)
target_include_directories(${BIN_NAME} PUBLIC
  ../../include/
  ../../include/dci/
  ../../include/DtkCore/
  ../../include/base/
  ../../include/global/
)
set_target_properties(${BIN_NAME} PROPERTIES OUTPUT_NAME ${TARGET_NAME})
install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

#end dci

=== debian/changelog ===
dtkcore (5.7.12-1build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 13 Jul 2025 16:21:08 +0300

dtkcore (5.7.12-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Add explicit binary dep libdtklog-dev.
  * debian/libdtkcore5.shlibs: Tighten version requirement.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Mar 2025 15:40:01 -0400

=== debian/control ===
Source: dtkcore
Section: libs
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Arun Kumar Pariyar <arun@debian.org>,
 Tu Qinggang <tuqinggang@uniontech.com>,
 Clay Stan <claystan97@gmail.com>,
 Hu Feng <hufeng@uniontech.com>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 doxygen <!nodoc>,
 libchardet-dev,
 libdtkcommon-dev (>= 5.7.12),
 libdtklog-dev,
 libgsettings-qt-dev,
 libgtest-dev,
 libicu-dev,
 libuchardet-dev,
 pkgconf,
 qtbase5-private-dev,
 qttools5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/linuxdeepin/dtkcore
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/dtkcore.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/dtkcore

Package: libdtkcore-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libdtkcommon-dev (>= 5.7.12),
 libdtklog-dev,
 libdtkcore5 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libdtkcommon-dev (<< 5.7.5),
 libdtkwidget-dev (<< 5.2.2.10-1),
Replaces:
 libdtkcommon-dev (<< 5.7.5),
 libdtkwidget-dev (<< 5.2.2.10-1),
Description: Deepin Tool Kit Core library (development files)
 DtkCore is a base library for Deepin Qt/C++ applications.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the header files and static libraries of DtkCore.

Package: libdtkcore5
Architecture: any
Multi-Arch: same
Depends:
 libdtkcommon,
 lshw,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Tool Kit Core library
 DtkCore is a base library of Deepin Qt/C++ applications.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains the shared libraries.

Package: libdtkcore5-bin
Architecture: any
Section: utils
Depends:
 libdtkcore5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 dtkcore-bin,
Description: Deepin Tool Kit Core library (utilities)
 DtkCore is a base devel library for Deepin Qt/C++ applications.
 .
 This package is part of DDE (Deepin Desktop Environment).
 .
 This package contains various command-line utilities used by Deepin Tool Kit
 and other Deepin software. Some tools were originally provided by DtkSettings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

export QT_SELECT := 5

# Explicitly enable hardening
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/architecture.mk

# Retrieve version info
include /usr/share/dpkg/default.mk

VERSION = $(DEB_VERSION_UPSTREAM)

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOC_OPTION := ON
else
  BUILD_DOC_OPTION := OFF
endif


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DBUILD_EXAMPLES=OFF \
            -DBUILD_DOCS=$(BUILD_DOC_OPTION) \
            -DBUILD_WITH_SYSTEMD=ON \
			-DDTK_VERSION=$(VERSION) \
            $(NULL)

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md


ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_install:
	# Manually install .qch file when documentation is being built
	dh_install debian/tmp/usr/share/qt5/doc/dtkcore.qch /usr/share/qt5/doc/
endif

## dtkcore 5.7.14

=== tools/qdbusxml2cpp/CMakeLists.txt ===
set(TARGET_NAME qdbusxml2cpp-fix)
set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)

add_executable(${BIN_NAME}
  qdbusxml2cpp.cpp
)

target_link_libraries(
  ${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::DBus
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::DBusPrivate
)

set_target_properties(
  ${BIN_NAME} PROPERTIES
  OUTPUT_NAME ${TARGET_NAME}
  EXPORT_NAME Xml2Cpp
)

install(
  TARGETS ${BIN_NAME}
  EXPORT Dtk${DTK_VERSION_MAJOR}ToolsTargets
  DESTINATION ${TOOL_INSTALL_DIR}
)

install(
  EXPORT Dtk${DTK_VERSION_MAJOR}ToolsTargets
  FILE Dtk${DTK_VERSION_MAJOR}ToolsTargets.cmake
  NAMESPACE Dtk${DTK_VERSION_MAJOR}::
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/Dtk${DTK_VERSION_MAJOR}Tools"
)

=== debian/changelog ===
dtkcore (5.7.14) unstable; urgency=medium

  * fix: resolve compilation failure on Qt 6.9

 -- JiDe Zhang <zhangjide@deepin.org>  Sat, 12 Apr 2025 17:19:00 +0800

dtkcore (5.7.13) unstable; urgency=medium

  * fix: add copyright for dconfig_org_deepin_dtk_preference.hpp
  * feat: supports create generic config by dconfig2cpp
  * fix: build failed on Qt6

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 20 Mar 2025 17:05:39 +0800

dtkcore (5.7.12) unstable; urgency=medium

  * feat: dconfig2cpp always add bindableFoo functions on Qt6
  * feat: Add files generated by qdbusXML2cpp and DCONG2cpp

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 06 Mar 2025 17:29:21 +0800

dtkcore (5.7.11) unstable; urgency=medium

  * feat: dconfig2cpp generated codes supports qml
  * feat: export ProductType for QML
  * feat: async get dconfig value for DLog
  * feat: support auto generate the Qt code from a dconfig's json

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 27 Feb 2025 20:47:22 +0800

dtkcore (5.7.10) unstable; urgency=medium

  * Release 5.7.10

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 13 Feb 2025 17:18:04 +0800

dtkcore (5.7.9) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 23 Jan 2025 09:07:08 +0000

dtkcore (5.7.8) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 14 Jan 2025 11:17:31 +0000

dtkcore (5.7.7) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 09 Jan 2025 09:28:38 +0000

dtkcore (5.7.6) unstable; urgency=medium

  [ root ]
  * UNRELEASED

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 02 Jan 2025 05:43:52 +0000

## dtkcore 5.7.16

=== debian/changelog ===
dtkcore (5.7.16) unstable; urgency=medium

  * fix: add missing UosMilitary edition type cases

 -- YeShanShan <yeshanshan@uniontech.com>  Mon, 19 May 2025 17:21:50 +0800

dtkcore (5.7.15) unstable; urgency=medium

  * fix: correct bitwise operation in dconfig status tracking
  * chore: update REUSE license file patterns
  * fix: add QPointer check for parent object safety

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 17:53:02 +0800

## dtkcore 5.7.18

=== debian/changelog ===
dtkcore (5.7.18) unstable; urgency=medium

  * Release 5.7.18

 --  yeshanshan <yeshanshan@uniontech.com>  Fri, 27 Jun 2025 17:07:16 +0800

dtkcore (5.7.17) unstable; urgency=medium

  * Release 5.7.17

 -- asterwyx <wangyixue@uniontech.com>  Wed, 18 Jun 2025 18:01:08 +0800

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export QT_SELECT = qt5
export DEB_CXXFLAGS_MAINT_APPEND = -Ofast

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(DEB_VERSION_UPSTREAM)

# Calculate build version:
# 5.6.8 -> 0; 5.6.8.7 -> 7; 5.6.8+u001 -> 1; 5.6.8.7+u001 -> 7; 5.6.8.0+u001 -> 0
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}' | awk -F'.' '{print $$4}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
ifeq ($(BUILD_VER), 0)
ifeq ($(shell expr $(shell echo "$(VERSION)" | awk -F. '{print NF-1}') '<' 3), 1)
	BUILD_VER=$(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}'  | sed 's/[^0-9]//g' | awk '{print int($$1)}')
endif
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_WITH_SYSTEMD=ON -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DBUILD_VERSION=$(BUILD_VER) -DD_DSG_APP_DATA_FALLBACK=/var/dsg/appdata

#override_dh_auto_test:
#	echo "skip auto test"

override_dh_makeshlibs:
	dh_makeshlibs -V "libdtkcore5 (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2))"

## dtkcore 5.7.19

=== debian/changelog ===
dtkcore (5.7.19) unstable; urgency=medium

  * Release 5.7.19

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 03 Jul 2025 21:11:07 +0800

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,12 @@
 include /usr/share/dpkg/default.mk
 export QT_SELECT = qt5
 export DEB_CXXFLAGS_MAINT_APPEND = -Ofast
+
+# 安全编译参数
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -Wall
+export DEB_CXXFLAGS_MAINT_APPEND = -Wall
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

## dtkcore 5.7.21

=== debian/changelog ===
dtkcore (5.7.21) unstable; urgency=medium

  * Release 5.7.21

 --  yeshanshan <packages@deepin.org>  Thu, 14 Aug 2025 19:47:41 +0800

dtkcore (5.7.20) unstable; urgency=medium

  * Release 5.7.20

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 31 Jul 2025 20:00:27 +0800

## dtkcore 5.7.24

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" DTK_FILE_VERSION)
string(STRIP "${DTK_FILE_VERSION}" DTK_FILE_VERSION)
set(DTK_VERSION "${DTK_FILE_VERSION}" CACHE STRING "DTK version")

project (DtkCore
  VERSION ${DTK_VERSION}
  DESCRIPTION "DTK Core module"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dtkcore"
  LANGUAGES CXX C
)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if("${PROJECT_VERSION_MAJOR}" STREQUAL "5")
    set(QT_VERSION_MAJOR "5")
elseif("${PROJECT_VERSION_MAJOR}" STREQUAL "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
else()
    message(SEND_ERROR "not support Prject Version ${PROJECT_VERSION}.")
endif()

include(dtkcore.cmake)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,20 @@
 
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
 find_package(Dtk${DTK_VERSION_MAJOR}Log REQUIRED)
+find_package(DBus1 REQUIRED)
 if(LINUX)
   find_package(PkgConfig REQUIRED)
   find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
-  if("${QT_VERSION_MAJOR}" STREQUAL "5")
+
+  if(${QT_VERSION_MAJOR} EQUAL 5)
       pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt) #Dtk6 removed.
+  elseif(${QT_VERSION_MAJOR} EQUAL 6)
+      if(${Qt6Core_VERSION} VERSION_GREATER_EQUAL 6.10.0)
+          find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS CorePrivate)
+      endif()
+  else()
+      message(FATAL_ERROR "Unsupported Qt version: ${QT_VERSION_MAJOR}")
   endif()
-
 endif()
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Xml)
 find_package(DtkBuildHelper REQUIRED)
@@ -23,6 +30,12 @@
 find_package(ICU REQUIRED COMPONENTS uc)
 pkg_check_modules(uchardet REQUIRED uchardet)
 # end text encoding
+
+# 为不包含实际QObject类的头文件跳过AutoMOC处理
+set_property(SOURCE ../include/base/dsingleton.h PROPERTY SKIP_AUTOMOC ON)
+if("${DTK_VERSION_MAJOR}" STREQUAL "6")
+    set_property(SOURCE ../include/util/dthreadutils.h PROPERTY SKIP_AUTOMOC ON)
+endif()
 
 # start base
 include(base/base.cmake)
@@ -114,6 +127,9 @@
     LIBDTKCORE_LIBRARY
 )
 
+target_link_libraries(${LIB_NAME} PRIVATE
+  dbus-1
+)
 target_include_directories(${LIB_NAME} PRIVATE
   ${uchardet_INCLUDE_DIRS}
 )

=== examples/textcodec-example/CMakeLists.txt ===
set(BIN_NAME textcodec${DTK_VERSION_MAJOR})

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

add_executable(${BIN_NAME}
    main.cpp
)

target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    ${LIB_NAME}
)

target_include_directories(${BIN_NAME} PUBLIC
    ../../include/util/
    ../../include/
)

=== tools/dci/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,13 @@
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
+
+if(${QT_VERSION_MAJOR} EQUAL 6)
+    if(${Qt6Core_VERSION} VERSION_GREATER_EQUAL 6.10.0)
+      find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS CorePrivate)
+    endif()
+endif()
+
 add_definitions(-DDTK_NO_PROJECT)
 # start dci
 include(../../src/dci/dci.cmake)

=== tools/dconfig2cpp/CMakeLists.txt ===
set(TARGET_NAME dconfig2cpp)
set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

add_executable(${BIN_NAME}
  main.cpp
)

target_link_libraries(
  ${BIN_NAME} PRIVATE
  Qt${QT_VERSION_MAJOR}::Core
)

set_target_properties(
  ${BIN_NAME} PROPERTIES
  OUTPUT_NAME ${TARGET_NAME}
  EXPORT_NAME DConfig2Cpp
)

install(
  TARGETS ${BIN_NAME}
  EXPORT Dtk${DTK_VERSION_MAJOR}ToolsTargets
  DESTINATION ${TOOL_INSTALL_DIR}
)

=== debian/changelog ===
dtkcore (5.7.24) unstable; urgency=medium

  * Release 5.7.24

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 16 Oct 2025 19:45:57 +0800

dtkcore (5.7.23) unstable; urgency=medium

  * Release 5.7.23

 --  yeshanshan <packages@deepin.org>  Thu, 25 Sep 2025 16:49:58 +0800

dtkcore (5.7.22) unstable; urgency=medium

  * Release 5.7.22

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 04 Sep 2025 19:27:28 +0800

=== debian/control ===
Source: dtkcore
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper-compat ( =12), pkg-config,
 qttools5-dev-tools, qttools5-dev, qtbase5-private-dev, doxygen,
 libgsettings-qt-dev, libgtest-dev, libdtkcommon-dev, cmake,
 libuchardet-dev, libicu-dev, libdtklog-dev, libdbus-1-dev
Standards-Version: 3.9.8

Package: libdtkcore5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lshw
Multi-Arch: same
Description: Deepin Tool Kit Core library
 DtkCore is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkcore5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkcore5( =${binary:Version})
Description: Deepin Tool Kit Core Utilities
 DtkCore is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the utilities of DtkCore

Package: libdtkcore-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdtkcore5( =${binary:Version}),
 libdtkcommon-dev(>=5.6.16), libdtklog-dev
Description: Deepin Tool Kit Core Devel library
 DtkCore is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries of DtkCore

Package: libdtkcore-doc
Architecture: any
Description: Deepin Tool Kit Core (document)
 DtkCore is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the doc files of DtkCore

## dtkcore 5.7.26

=== debian/changelog ===
dtkcore (5.7.26) unstable; urgency=medium

  * Release 5.7.26

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 06 Nov 2025 17:02:30 +0800

dtkcore (5.7.25) unstable; urgency=medium

  * Release 5.7.25

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 30 Oct 2025 21:47:32 +0800

## dtkcore 6.7.33

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" FILE_VERSION)
string(STRIP "${FILE_VERSION}" FILE_VERSION)

project (DtkCore
  VERSION ${FILE_VERSION}
  DESCRIPTION "DTK Core module"
  HOMEPAGE_URL "https://github.com/linuxdeepin/dtkcore"
  LANGUAGES CXX C
)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

option(DTK5 "Build DTK5." ON)
if(DTK5)
    set(DTK_VERSION_MAJOR "5")
    set(DTK_NAME_SUFFIX "") # Empty name suffix for DTK5 products.
else()
    set(DTK_VERSION_MAJOR "6")
    set(DTK_NAME_SUFFIX "6")
endif()

set(DTK_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(DTK_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(DTK_VERSION "${DTK_VERSION_MAJOR}.${DTK_VERSION_MINOR}.${DTK_VERSION_PATCH}")
# Officially, DTK5 uses QT5, DTK6 uses QT6
set(QT_VERSION_MAJOR ${DTK_VERSION_MAJOR})

include(dtkcore.cmake)

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set (DOXYGEN_GENERATE_XML YES CACHE STRING "Doxygen XML output")
 set (DOXYGEN_GENERATE_QHP YES CACHE STRING "Doxygen QHP output")
 set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.zh_CN.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
-set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
+set (DOXYGEN_PROJECT_NUMBER ${DTK_VERSION} CACHE STRING "") # Should be the same as this project is using.
 set (DOXYGEN_EXTRACT_STATIC YES)
 set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set(CMAKE_AUTORCC ON)
 
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
-find_package(Dtk${DTK_VERSION_MAJOR}Log REQUIRED)
+find_package(Dtk${DTK_NAME_SUFFIX}Log REQUIRED)
 find_package(DBus1 REQUIRED)
 if(LINUX)
   find_package(PkgConfig REQUIRED)
@@ -77,7 +77,7 @@
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::DBus
     Qt${QT_VERSION_MAJOR}::Xml
-    Dtk${DTK_VERSION_MAJOR}::Log
+    Dtk${DTK_NAME_SUFFIX}::Log
   )
   target_link_libraries(${LIB_NAME} PRIVATE
     Qt${QT_VERSION_MAJOR}::CorePrivate
@@ -113,8 +113,8 @@
   endif()
 endif()
 set_target_properties(${LIB_NAME} PROPERTIES
-  VERSION ${CMAKE_PROJECT_VERSION}
-  SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
+  VERSION ${DTK_VERSION}
+  SOVERSION ${DTK_VERSION_MAJOR}
   EXPORT_NAME Core
 )
 
@@ -144,6 +144,7 @@
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/settings>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/filesystem>
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
+  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
 )
 
 target_include_directories(${LIB_NAME} INTERFACE
@@ -190,6 +191,6 @@
 
 install(EXPORT ${DtkCore}Targets
   FILE ${DtkCore}Targets.cmake
-  NAMESPACE Dtk${DTK_VERSION_MAJOR}::
+  NAMESPACE Dtk${DTK_NAME_SUFFIX}::
   DESTINATION ${CONFIG_CMAKE_INSTALL_DIR}
 )

=== tests/CMakeLists.txt ===
# 方便 test 脚本中调用
set(BIN_NAME "ut-DtkCore")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
# dbus
set(CMAKE_CXX_FLAGS "-fno-access-control")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_compile_options(-fsanitize=address)
    add_link_options(-fsanitize=address)
endif()

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

if(LINUX)
    find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)
    find_package(PkgConfig REQUIRED)
    if("${QT_VERSION_MAJOR}" STREQUAL "5")
        pkg_check_modules(QGSettings REQUIRED IMPORTED_TARGET gsettings-qt)
    elseif(${QT_VERSION_MAJOR} EQUAL 6)
        if(${Qt6Core_VERSION} VERSION_GREATER_EQUAL 6.10.0)
            find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS CorePrivate)
        endif()
    else()
        message(FATAL_ERROR "Unsupported Qt version: ${QT_VERSION_MAJOR}")
    endif()
endif()

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Xml)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Concurrent)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)
find_package(GTest REQUIRED)

include(GoogleTest)

# for test.so
set(TEST_SO_NAME vtabletest${DTK_NAME_SUFFIX})
add_subdirectory(./testso)

# test
file(GLOB TEST_HEADER ut_.*h)
file(GLOB TEST_SOURCE *.cpp)

file(GLOB FackDBus
    "./fakedbus/*.h"
    "./fakedbus/*.cpp"
)

if(NOT DTK5)
    list(REMOVE_ITEM TEST_SOURCE "${CMAKE_CURRENT_LIST_DIR}/ut_gsettingsbackend.cpp")
    list(REMOVE_ITEM TEST_SOURCE "${CMAKE_CURRENT_LIST_DIR}/ut_dasync.cpp")
endif()

set(test_SRC
    ${TEST_HEADER}
    ${TEST_SOURCE}
    ${FackDBus}
)
# end test

add_executable(${BIN_NAME}
    ${test_SRC}
    ./data.qrc
)

target_compile_definitions(${BIN_NAME} PUBLIC
    PREFIX="${DSG_PREFIX_PATH}"
    DSYSINFO_PREFIX="${DSYSINFO_PREFIX}"
)

add_dependencies(${BIN_NAME} ${TEST_SO_NAME})
target_link_libraries(
    ${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::CorePrivate
    Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::Test
    ${GTEST_LIBRARIES}
    ${LIB_NAME}
    -l${TEST_SO_NAME}
)

if(LINUX)
    if(${QT_VERSION_MAJOR} STREQUAL "5")
          target_link_libraries(
              ${BIN_NAME} PRIVATE
              PkgConfig::QGSettings
          )
    endif()

    target_link_libraries(
        ${BIN_NAME} PRIVATE
        Qt${QT_VERSION_MAJOR}::DBus
        -lpthread
        -lm
        -lgcov
        -ldl
    )
endif() #end LINUX

target_link_directories(${BIN_NAME} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/testso/)
target_include_directories( ${BIN_NAME} PUBLIC
    ../include/util/
    ../include/dci/
    ../include/log/
    ../include/base/
    ../include/base/private/
    ../include/global/
    ../include/DtkCore/
    ../include/settings/
    ../include/filesystem/
    ../include/
    ../src/log/
    ./testso/
)

# Set RPATH to find libvtabletest*.so in the build directory
set_target_properties(${BIN_NAME} PROPERTIES
    SKIP_BUILD_RPATH FALSE
)

gtest_discover_tests(${BIN_NAME})

=== examples/dlog-example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(BIN_NAME dlog${DTK_VERSION_MAJOR})
+set(BIN_NAME dlog${DTK_NAME_SUFFIX})
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

=== examples/expintf-example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(BIN_NAME exprintf${DTK_VERSION_MAJOR})
+set(BIN_NAME exprintf${DTK_NAME_SUFFIX})
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS DBus)

=== examples/filewatcher-example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(BIN_NAME filewatcher${DTK_VERSION_MAJOR})
+set(BIN_NAME filewatcher${DTK_NAME_SUFFIX})
 
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

=== examples/textcodec-example/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(BIN_NAME textcodec${DTK_VERSION_MAJOR})
+set(BIN_NAME textcodec${DTK_NAME_SUFFIX})
 
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

=== tools/ch2py/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set(TARGET_NAME ch2py)
-set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})
+set(BIN_NAME ${TARGET_NAME}${DTK_NAME_SUFFIX})
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
@@ -14,8 +14,9 @@
     Qt${QT_VERSION_MAJOR}::Core
 )
 target_include_directories(${BIN_NAME} PRIVATE
-    ${PROJECT_SOURCE_DIR}/include/util
-    ${PROJECT_SOURCE_DIR}/include/global
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/util>
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
+    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
 )
 set_target_properties(${BIN_NAME} PROPERTIES OUTPUT_NAME ${TARGET_NAME})
 install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== tools/dci/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set(TARGET_NAME dci)
-set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})
+set(BIN_NAME ${TARGET_NAME}${DTK_NAME_SUFFIX})
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)

=== tools/dconfig2cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set(TARGET_NAME dconfig2cpp)
-set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})
+set(BIN_NAME ${TARGET_NAME}${DTK_NAME_SUFFIX})
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
@@ -21,6 +21,6 @@
 
 install(
   TARGETS ${BIN_NAME}
-  EXPORT Dtk${DTK_VERSION_MAJOR}ToolsTargets
+  EXPORT Dtk${DTK_NAME_SUFFIX}ToolsTargets
   DESTINATION ${TOOL_INSTALL_DIR}
 )

=== tools/deepin-os-release/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,15 @@
 set(TARGET_NAME deepin-os-release)
-set(BIN_NAME ${TARGET_NAME}${DTK_VERSION_MAJOR})
+set(BIN_NAME ${TARGET_NAME}${DTK_NAME_SUFFIX})
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 set(CMAKE_AUTOMOC ON)
 find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
+if(${QT_VERSION_MAJOR} EQUAL 6)
+    if(${Qt6Core_VERSION} VERSION_GREATER_EQUAL 6.10.0)
+      find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS CorePrivate)
+    endif()
+endif()
+
 add_definitions(-DDTK_NO_PROJECT)
 # start dci
 set(dci_SRCS
@@ -25,11 +31,12 @@
   Qt${QT_VERSION_MAJOR}::CorePrivate
 )
 target_include_directories(${BIN_NAME} PUBLIC
-  ../../include/
-  ../../include/dci/
-  ../../include/DtkCore/
-  ../../include/base/
-  ../../include/global/
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/dci>
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/DtkCore>
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/base>
+    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/global>
+    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
 )
 set_target_properties(${BIN_NAME} PROPERTIES OUTPUT_NAME ${TARGET_NAME})
 install(TARGETS ${BIN_NAME} DESTINATION "${TOOL_INSTALL_DIR}")

=== debian/changelog ===
dtkcore (6.7.33) unstable; urgency=medium

  * Release 6.7.33

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 05 Feb 2026 17:27:03 +0800

dtkcore (6.7.32) unstable; urgency=medium

  * Release 6.7.32

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 22 Jan 2026 16:53:52 +0800

dtkcore (6.7.31) unstable; urgency=medium

  * Release 6.7.31

 --  yeshanshan <yeshanshan@uniontech.com>  Tue, 06 Jan 2026 13:16:35 +0800

dtkcore (5.7.30) unstable; urgency=medium

  * Release 5.7.30

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 11 Dec 2025 20:58:19 +0800

dtkcore (5.7.28) unstable; urgency=medium

  * Release 5.7.28

 -- mhduiy <zhangkun2@uniontech.com>  Thu, 04 Dec 2025 19:52:58 +0800

dtkcore (5.7.27) unstable; urgency=medium

  * Release 5.7.27

 -- mhduiy <zhangkun2@uniontech.com>  Thu, 27 Nov 2025 19:39:07 +0800

=== debian/control ===
Source: dtkcore
Section: libdevel
Priority: optional
Maintainer: Shanshan Ye <yeshanshan@uniontech.com>
Build-Depends: debhelper-compat ( =12),
    cmake,
    pkg-config,
    libgtest-dev,
    libdtkcommon-dev,
    libicu-dev,
    libuchardet-dev,
    libdbus-1-dev,
    qttools5-dev-tools <!nodtk5>,
    qttools5-dev <!nodtk5>,
    libgsettings-qt-dev <!nodtk5>,
    libdtklog-dev <!nodtk5>,
    qtbase5-private-dev <!nodtk5>,
    qt6-base-dev-tools <!nodtk6>,
    qt6-base-dev <!nodtk6>,
    qt6-base-private-dev <!nodtk6>,
    libdtk6log-dev <!nodtk6>,
    qt6-tools-dev <!nodtk6>,
    doxygen <!nodoc>
Standards-Version: 3.9.8

Package: libdtk6core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lshw
Multi-Arch: same
Build-Profiles: <!nodtk6>
Description: Development ToolKit Core Library (DTK6 with Qt6)
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the shared libraries for DTK6 applications.

Package: libdtk6core-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtk6core( =${binary:Version})
Build-Profiles: <!nodtk6>
Description: Development ToolKit Core Utilities (DTK6 with Qt6)
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the utilities of DTK6 Core.

Package: libdtk6core-dev
Architecture: any
Depends: libdtk6core( =${binary:Version}),
 libdtkcommon-dev(>=5.6.16), libdtk6log-dev
Build-Profiles: <!nodtk6>
Description: Development ToolKit Core Devel Library (DTK6 with Qt6)
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the header files and development library symbolic links of DTK6 Core.

Package: libdtk6core-doc
Architecture: any
Build-Profiles: <!nodtk6 !nodoc>
Description: Development ToolKit Core Documentation
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the doc files of DtkCore.

Package: libdtkcore5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lshw
Multi-Arch: same
Build-Profiles: <!nodtk5>
Description: Development ToolKit Core Library (DTK5 with Qt5)
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the shared libraries for DTK5 applications.

Package: libdtkcore5-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtkcore5( =${binary:Version})
Build-Profiles: <!nodtk5>
Description: Development ToolKit Core Utilities (DTK5 with Qt5)
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the utilities of DTK5 Core.

Package: libdtkcore-dev
Architecture: any
Depends: libdtkcore5( =${binary:Version}),
 libdtkcommon-dev(>=5.6.16), libdtklog-dev
Build-Profiles: <!nodtk5>
Description: Development ToolKit Core Devel Library (DTK5 with Qt5)
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the header files and development library symbolic links of DTK5 Core.

Package: libdtkcore-doc
Architecture: any
Build-Profiles: <!nodtk5 !nodoc>
Description: Development ToolKit Core Documentation
 DTK Core is the base library of deepin Qt/C++ applications.
 .
 This package contains the doc files of DtkCore.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export DEB_CXXFLAGS_MAINT_APPEND = -Ofast

# 安全编译参数
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall
export DEB_CXXFLAGS_MAINT_APPEND = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E

# reproducible编译参数
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_SKIP_BUILD_RPATH=ON

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Calculate build version:
# 5.6.8 -> 0; 5.6.8.7 -> 7; 5.6.8+u001 -> 1; 5.6.8.7+u001 -> 7; 5.6.8.0+u001 -> 0
BUILD_VER := $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$1}' | awk -F'.' '{print $$4}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')
ifeq ($(BUILD_VER), 0)
ifeq ($(shell expr $(shell echo "$(DEB_VERSION_UPSTREAM)" | awk -F. '{print NF-1}') '<' 3), 1)
	BUILD_VER=$(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$2}'  | sed 's/[^0-9]//g' | awk '{print int($$1)}')
endif
endif

BUILD_DOCS := $(if $(filter nodoc,$(DEB_BUILD_PROFILES)),OFF,ON)
BUILD_DTK5 := $(if $(filter nodtk5,$(DEB_BUILD_PROFILES)),OFF,ON)
BUILD_DTK6 := $(if $(filter nodtk6,$(DEB_BUILD_PROFILES)),OFF,ON)

%:
	dh $@

override_dh_auto_configure:
ifeq ($(BUILD_DTK5),ON)
	mkdir -p build5
	QT_SELECT=qt5 dh_auto_configure --builddirectory=build5 -- $(DEB_CMAKE_EXTRA_FLAGS) -DBUILD_WITH_SYSTEMD=ON -DBUILD_EXAMPLES=OFF -DBUILD_TESTING=OFF -DBUILD_DOCS=$(BUILD_DOCS) -DBUILD_VERSION=$(BUILD_VER) -DD_DSG_APP_DATA_FALLBACK=/var/dsg/appdata -DDTK5=ON
endif
ifeq ($(BUILD_DTK6),ON)
	mkdir -p build6
	dh_auto_configure --builddirectory=build6 -- $(DEB_CMAKE_EXTRA_FLAGS) -DBUILD_WITH_SYSTEMD=ON -DBUILD_EXAMPLES=OFF -DBUILD_TESTING=OFF -DBUILD_DOCS=$(BUILD_DOCS) -DBUILD_VERSION=$(BUILD_VER) -DD_DSG_APP_DATA_FALLBACK=/var/dsg/appdata -DDTK5=OFF
endif

override_dh_auto_build:
ifeq ($(BUILD_DTK5),ON)
	QT_SELECT=qt5 dh_auto_build --builddirectory=build5
endif
ifeq ($(BUILD_DTK6),ON)
	dh_auto_build --builddirectory=build6
endif

override_dh_auto_install:
ifeq ($(BUILD_DTK5),ON)
	QT_SELECT=qt5 dh_auto_install --builddirectory=build5
endif
ifeq ($(BUILD_DTK6),ON)
	dh_auto_install --builddirectory=build6
endif

override_dh_link:
ifeq ($(BUILD_DTK5),ON)
	dh_link usr/lib/$(DEB_HOST_MULTIARCH)/libdtkcore.so.5 usr/lib/$(DEB_HOST_MULTIARCH)/libdtkcore.so -p libdtkcore-dev
endif
ifeq ($(BUILD_DTK6),ON)
	dh_link usr/lib/$(DEB_HOST_MULTIARCH)/libdtk6core.so.6 usr/lib/$(DEB_HOST_MULTIARCH)/libdtk6core.so -p libdtk6core-dev
endif

override_dh_auto_test:
ifeq ($(BUILD_DTK5),ON)
	QT_SELECT=qt5 dh_auto_test --builddirectory=build5
endif
ifeq ($(BUILD_DTK6),ON)
	dh_auto_test --builddirectory=build6
endif
